Index: /trunk/LMDZ.PLUTO/libf/phypluto/surfini.F
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/surfini.F	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/surfini.F	(revision 3195)
@@ -3,5 +3,5 @@
 
       USE surfdat_h, only: albedodat
-      USE tracer_h, only: igcm_n2_ice
+      USE tracer_h, only: igcm_haze
       use planetwide_mod, only: planetwide_maxval, planetwide_minval
       use radinc_h, only : L_NSPECTV
@@ -9,10 +9,10 @@
 
       IMPLICIT NONE
-      
-      
+
+
 ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 cccccccccccccc                                                                 cccccccccccccc
 cccccccccccccc   Spectral Albedo Initialisation - Routine modified by MT2015.  cccccccccccccc
-cccccccccccccc                                                                 cccccccccccccc 
+cccccccccccccc                                                                 cccccccccccccc
 ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 
@@ -56,16 +56,16 @@
 
       ! Step 3 : We modify the albedo considering some N2 at the surface. We dont take into account water ice (this is made in hydrol after the first timestep) ...
-      if (igcm_n2_ice.ne.0) then
+      if (igcm_haze.ne.0) then
          DO ig=1,ngrid
-            IF (qsurf(ig,igcm_n2_ice) .GT. 1.) THEN ! This was changed by MT2015. Condition for ~1mm of N2 ice deposit.
+            IF (qsurf(ig,igcm_haze) .GT. 1.) THEN ! This was changed by MT2015. Condition for ~1mm of N2 ice deposit.
 	       DO nw=1,L_NSPECTV
 	          albedo(ig,nw)=albedo_n2_ice_SPECTV(nw)
 	       ENDDO
-            END IF   
-         ENDDO   
+            END IF
+         ENDDO
       else
          write(*,*) "surfini: No N2 ice tracer on surface  ..."
          write(*,*) "         and therefore no albedo change."
-      endif     
+      endif
       call planetwide_minval(albedo,min_albedo)
       call planetwide_maxval(albedo,max_albedo)
Index: /trunk/LMDZ.PLUTO/libf/phypluto/tracer_h.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/tracer_h.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/tracer_h.F90	(revision 3195)
@@ -14,5 +14,5 @@
 
        character*30, save, allocatable :: noms(:)   ! name of the tracer
-       real, save, allocatable :: mmol(:)     ! mole mass of tracer (g/mol) 
+       real, save, allocatable :: mmol(:)     ! mole mass of tracer (g/mol)
        real, save, allocatable :: aki(:)      ! to compute coefficient of thermal concduction if photochem
        real, save, allocatable :: cpi(:)      ! to compute cpnew in concentration.F if photochem
@@ -28,8 +28,14 @@
        real,save :: rho_dust     ! Mars dust density (kg.m-3)
        real,save :: rho_ice     ! Water ice density (kg.m-3)
+       real,save :: rho_ch4_ice     ! ch4 ice density (kg.m-3)
+       real,save :: rho_co_ice     ! co ice density (kg.m-3)
        real,save :: rho_n2     ! N2 ice density (kg.m-3)
+       real,save :: lw_ch4     ! Latent heat CH4 gas -> solid
+       real,save :: lw_co      ! Latent heat CO gas -> solid
+       real,save :: lw_n2      ! Latent heat N2 gas -> solid
+       integer,save :: nmono
        real,save :: ref_r0        ! for computing reff=ref_r0*r0 (in log.n. distribution)
 !$OMP THREADPRIVATE(noms,mmol,aki,cpi,radius,rho_q,qext,alpha_lift,alpha_devil,qextrhor, &
-	!$OMP varian,r3n_q,rho_dust,rho_ice,rho_n2,ref_r0)
+	!$OMP varian,r3n_q,rho_dust,rho_ice,rho_n2,lw_n2,ref_r0)
 
        integer, save, allocatable :: is_chim(:) ! 1 if tracer used in chemistry, else 0
@@ -59,59 +65,27 @@
 ! tracer indexes: these are initialized in initracer and should be 0 if the
 !                 corresponding tracer does not exist
-       ! dust
-       integer,save,allocatable :: igcm_dustbin(:) ! for dustbin 'dust' tracers
-       ! dust, special doubleq case
-       integer,save :: igcm_dust_mass   ! dust mass mixing ratio (for transported dust)
-       integer,save :: igcm_dust_number ! dust number mixing ratio (transported dust)
-       ! water
-       integer,save :: igcm_h2o_vap ! water vapour
-       integer,save :: igcm_h2o_ice ! water ice
-       ! chemistry:
-       integer,save :: igcm_co2
-       integer,save :: igcm_co
-       integer,save :: igcm_o
-       integer,save :: igcm_o1d
-       integer,save :: igcm_o2
-       integer,save :: igcm_o3
-       integer,save :: igcm_h
-       integer,save :: igcm_h2
-       integer,save :: igcm_oh
-       integer,save :: igcm_ho2
-       integer,save :: igcm_h2o2
+
+       !Pluto chemistry
+       integer,save :: igcm_co_gas
        integer,save :: igcm_n2
        integer,save :: igcm_ar
-       integer,save :: igcm_n
-       integer,save :: igcm_no
-       integer,save :: igcm_no2
-       integer,save :: igcm_n2d
-       integer,save :: igcm_ch4
+       integer,save :: igcm_ch4_gas ! methane gas
+       ! other tracers
+       integer,save :: igcm_ar_n2 ! for simulations using co2 +neutral gaz
+       integer,save :: igcm_ch4_ice ! methane ice
+       integer,save :: igcm_co_ice ! methane ice
+       integer,save :: igcm_prec_haze
+       integer,save :: igcm_haze
+       integer,save :: igcm_haze10
+       integer,save :: igcm_haze30
+       integer,save :: igcm_haze50
+       integer,save :: igcm_haze100
+       integer,save :: igcm_eddy1e6
+       integer,save :: igcm_eddy1e7
+       integer,save :: igcm_eddy5e7
+       integer,save :: igcm_eddy1e8
+       integer,save :: igcm_eddy5e8
 
-       integer,save :: igcm_ch3
-       integer,save :: igcm_ch
-       integer,save :: igcm_3ch2
-       integer,save :: igcm_1ch2
-       integer,save :: igcm_cho
-       integer,save :: igcm_ch2o
-       integer,save :: igcm_ch3o
-       integer,save :: igcm_c
-       integer,save :: igcm_c2
-       integer,save :: igcm_c2h
-       integer,save :: igcm_c2h2
-       integer,save :: igcm_c2h3
-       integer,save :: igcm_c2h4
-       integer,save :: igcm_c2h6
-       integer,save :: igcm_ch2co
-       integer,save :: igcm_ch3co
-       integer,save :: igcm_hcaer
-
-       ! other tracers
-       integer,save :: igcm_ar_n2 ! for simulations using n2 +neutral gaz
-       integer,save :: igcm_n2_ice ! N2 ice 
-!$OMP THREADPRIVATE(igcm_dustbin,igcm_dust_mass,igcm_dust_number,igcm_h2o_vap,igcm_h2o_ice,      &
-	!$OMP igcm_co2,igcm_co,igcm_o,igcm_o1d,igcm_o2,igcm_o3,igcm_h,igcm_h2,igcm_oh,	      &
-	!$OMP igcm_ho2,igcm_h2o2,igcm_n2,igcm_ar,igcm_ar_n2,igcm_n2_ice,                         &
-       !$OMP igcm_n,igcm_no,igcm_no2,igcm_n2d,igcm_ch4,igcm_ch3,igcm_ch,igcm_3ch2,               &
-       !$OMP igcm_1ch2,igcm_cho,igcm_ch2o,igcm_ch3o,igcm_c,igcm_c2,igcm_c2h,igcm_c2h2,           &
-       !$OMP igcm_c2h3,igcm_c2h4,igcm_c2h6,igcm_ch2co,igcm_ch3co,igcm_hcaer)
+!$OMP THREADPRIVATE(igcm_co_gas,igcm_n2,igcm_ar,igcm_ch4_gas,igcm_ar_n2,&igcm_ch4_ice,igcm_co_ice,igcm_prec_haze,igcm_haze,igcm_haze10,igcm_haze30,igcm_haze50,igcm_haze100,igcm_eddy1e6,igcm_eddy1e7,igcm_eddy5e7,igcm_eddy1e8,igcm_eddy5e8)
 
        end module tracer_h
Index: /trunk/LMDZ.PLUTO/libf/phypluto/vdifc_mod.F
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/vdifc_mod.F	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/vdifc_mod.F	(revision 3195)
@@ -1,10 +1,10 @@
       module vdifc_mod
-      
+
       implicit none
-      
+
       contains
-      
-      subroutine vdifc(ngrid,nlay,nq,ppopsk,         
-     &     ptimestep,pcapcal,lecrit,                        
+
+      subroutine vdifc(ngrid,nlay,nq,ppopsk,
+     &     ptimestep,pcapcal,lecrit,
      &     pplay,pplev,pzlay,pzlev,pz0,
      &     pu,pv,ph,pq,ptsrf,pemis,pqsurf,
@@ -13,9 +13,8 @@
      &     pdqdif,pdqsdif)
 
-!      use watercommon_h, only : RLVTT, T_h2O_ice_liq, RCPD, mx_eau_sol 
+!      use watercommon_h, only : RLVTT, T_h2O_ice_liq, RCPD, mx_eau_sol
 !     &    ,Psat_water, Lcpdqsat_water
       use radcommon_h, only : sigma
       use surfdat_h, only: dryness
-      use tracer_h, only: igcm_h2o_vap, igcm_h2o_ice
       use comcstfi_mod, only: g, r, cpp, rcp
       use callkeys_mod, only: tracer,nosurf
@@ -24,9 +23,9 @@
 
 !==================================================================
-!     
+!
 !     Purpose
 !     -------
 !     Turbulent diffusion (mixing) for pot. T, U, V and tracers
-!     
+!
 !     Implicit scheme
 !     We start by adding to variables x the physical tendencies
@@ -34,10 +33,10 @@
 !
 !     x(t+1) =  x(t) + dt * (dx/dt)phys(t)  +  dt * (dx/dt)difv(t+1)
-!     
+!
 !     Authors
-!     ------- 
+!     -------
 !     F. Hourdin, F. Forget, R. Fournier (199X)
 !     R. Wordsworth, B. Charnay (2010)
-!     
+!
 !==================================================================
 
@@ -62,5 +61,5 @@
       REAL,INTENT(IN) :: pcapcal(ngrid)
       REAL,INTENT(INOUT) :: pq2(ngrid,nlay+1)
-      
+
 !     Arguments added for condensation
       REAL,INTENT(IN) :: ppopsk(ngrid,nlay)
@@ -70,10 +69,10 @@
 !     Tracers
 !     --------
-      integer,intent(in) :: nq 
+      integer,intent(in) :: nq
       real,intent(in) :: pqsurf(ngrid,nq)
-      real,intent(in) :: pq(ngrid,nlay,nq), pdqfi(ngrid,nlay,nq) 
-      real,intent(out) :: pdqdif(ngrid,nlay,nq) 
-      real,intent(out) :: pdqsdif(ngrid,nq) 
-      
+      real,intent(in) :: pq(ngrid,nlay,nq), pdqfi(ngrid,nlay,nq)
+      real,intent(out) :: pdqdif(ngrid,nlay,nq)
+      real,intent(out) :: pdqsdif(ngrid,nq)
+
 !     local
 !     -----
@@ -101,5 +100,5 @@
       SAVE firstcall
 !$OMP THREADPRIVATE(firstcall)
-      
+
 !     variables added for N2 condensation
 !     ------------------------------------
@@ -134,6 +133,6 @@
       real masse, Wtot, Wdiff
 
-      real dqsdif_total(ngrid) 
-      real zq0(ngrid) 
+      real dqsdif_total(ngrid)
+      real zq0(ngrid)
 
       forceWC=.true.
@@ -151,10 +150,4 @@
 !     PRINT*,'          acond,bcond',acond,bcond
 
-!         if(water)then
-!                iliq=igcm_h2o_vap
-!                ivap=igcm_h2o_vap
-!                iice=igcm_h2o_ice ! simply to make the code legible               
-!                                  ! to be generalised later
-!         endif
 
          firstcall=.false.
@@ -208,5 +201,5 @@
             DO ilev=1,nlay
                DO ig=1,ngrid
-                  zq(ig,ilev,iq)=pq(ig,ilev,iq) + 
+                  zq(ig,ilev,iq)=pq(ig,ilev,iq) +
      &                 pdqfi(ig,ilev,iq)*ptimestep
                ENDDO
@@ -220,5 +213,5 @@
 !
 !     Source of turbulent kinetic energy at the surface
-!     ------------------------------------------------- 
+!     -------------------------------------------------
 !     Formula is Cd_0 = (karman / log[1+z1/z0])^2
 
@@ -242,5 +235,5 @@
 
 !     Turbulent diffusion coefficients in the boundary layer
-!     ------------------------------------------------------ 
+!     ------------------------------------------------------
 
       call vdif_kc(ngrid,nlay,ptimestep,g,pzlev,pzlay
@@ -272,5 +265,5 @@
 !     donc les entrees sont /zcdv/ pour la condition a la limite sol
 !     et /zkv/ = Ku
-      
+
       CALL multipl((nlay-1)*ngrid,zkv(1,2),zb0(1,2),zb(1,2))
       CALL multipl(ngrid,zcdv,zb0,zb)
@@ -405,5 +398,5 @@
 !             z1(ig) = pcapcal(ig)*ptsrf(ig) + cpp*zb(ig,1)*zc(ig,1)
 !      &           + zdplanck(ig)*ptsrf(ig) + pfluxsrf(ig)*ptimestep
-!             z2(ig) = pcapcal(ig) + cpp*zb(ig,1)*(1.-zd(ig,1)) 
+!             z2(ig) = pcapcal(ig) + cpp*zb(ig,1)*(1.-zd(ig,1))
 !      &           +zdplanck(ig)
 !             ztsrf2(ig) = z1(ig) / z2(ig)
@@ -432,5 +425,5 @@
 !     Calculate vertical flux from the bottom to the first layer (dust)
 !     -----------------------------------------------------------------
-         do ig=1,ngrid  
+         do ig=1,ngrid
             rho(ig) = zb0(ig,1) /ptimestep
          end do
@@ -440,7 +433,7 @@
 !     Implicit inversion of q
 !     -----------------------
-         do iq=1,nq 
-
-            if (iq.ne.igcm_h2o_vap) then
+         do iq=1,nq
+
+            ! if (iq.ne.igcm_h2o_vap) then
 
                DO ig=1,ngrid
@@ -448,6 +441,6 @@
                   zcq(ig,nlay)=za(ig,nlay)*zq(ig,nlay,iq)*z1(ig)
                   zdq(ig,nlay)=zb(ig,nlay)*z1(ig)
-               ENDDO 
-            
+               ENDDO
+
                DO ilay=nlay-1,2,-1
                   DO ig=1,ngrid
@@ -460,16 +453,4 @@
                ENDDO
 
-   !             if ((water).and.(iq.eq.iice)) then
-   !                ! special case for water ice tracer: do not include
-   !                ! h2o ice tracer from surface (which is set when handling
-   !                ! h2o vapour case (see further down).
-   !                ! zb(ig,1)=0 if iq ne ivap
-   !                DO ig=1,ngrid
-   !                   z1(ig)=1./(za(ig,1)+
-   !   &                    zb(ig,2)*(1.-zdq(ig,2)))
-   !                   zcq(ig,1)=(za(ig,1)*zq(ig,1,iq)+
-   !   &                    zb(ig,2)*zcq(ig,2))*z1(ig)
-   !                ENDDO
-   !             else             ! general case
                   DO ig=1,ngrid
                      z1(ig)=1./(za(ig,1)+
@@ -497,6 +478,4 @@
                end do
 
-            endif               ! if (iq.ne.igcm_h2o_vap)
-
 !     Removed (AF24): Calculate temperature tendency including latent heat term
 !     and assuming an infinite source of water on the ground
@@ -517,5 +496,5 @@
             pdvdif(ig,ilev)=(zv(ig,ilev)-
      &           (pv(ig,ilev)))/ptimestep
-            hh = ph(ig,ilev)+pdhfi(ig,ilev)*ptimestep 
+            hh = ph(ig,ilev)+pdhfi(ig,ilev)*ptimestep
 
             pdhdif(ig,ilev)=( zh(ig,ilev)- hh )/ptimestep
@@ -525,5 +504,5 @@
       DO ig=1,ngrid  ! computing sensible heat flux (atm => surface)
 	 sensibFlux(ig)=cpp*zb(ig,1)/ptimestep*(zh(ig,1)-ztsrf2(ig))
-      ENDDO      
+      ENDDO
 
       if (tracer) then
@@ -561,5 +540,5 @@
 !          endif
 
-      endif 
+      endif
 
       ! if(water)then
